Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 1200)
@@ -1678,338 +1765,426 @@
 #endif
 
+
 /// SPS class
 class TComSPS
 {
 private:
-  Int         m_SPSId;
-  Int         m_VPSId;
-  Int         m_chromaFormatIdc;
-
-  UInt        m_uiMaxTLayers;           // maximum number of temporal layers
+  Int              m_SPSId;
+  Int              m_VPSId;
+  ChromaFormat     m_chromaFormatIdc;
+
+  UInt             m_uiMaxTLayers;           // maximum number of temporal layers
 
   // Structure
-  UInt        m_picWidthInLumaSamples;
-  UInt        m_picHeightInLumaSamples;
+  UInt             m_picWidthInLumaSamples;
+  UInt             m_picHeightInLumaSamples;
+
+  Int              m_log2MinCodingBlockSize;
+  Int              m_log2DiffMaxMinCodingBlockSize;
+  UInt             m_uiMaxCUWidth;
+  UInt             m_uiMaxCUHeight;
+  UInt             m_uiMaxTotalCUDepth; ///< Total CU depth, relative to the smallest possible transform block size.
+
+  Window           m_conformanceWindow;
+
+  TComRPSList      m_RPSList;
+  Bool             m_bLongTermRefsPresent;
+  Bool             m_TMVPFlagsPresent;
+  Int              m_numReorderPics[MAX_TLAYER];
+
+  // Tool list
+  UInt             m_uiQuadtreeTULog2MaxSize;
+  UInt             m_uiQuadtreeTULog2MinSize;
+  UInt             m_uiQuadtreeTUMaxDepthInter;
+  UInt             m_uiQuadtreeTUMaxDepthIntra;
+  Bool             m_usePCM;
+  UInt             m_pcmLog2MaxSize;
+  UInt             m_uiPCMLog2MinSize;
+  Bool             m_useAMP;
+
+  // Parameter
+  BitDepths        m_bitDepths;
+  Int              m_qpBDOffset[MAX_NUM_CHANNEL_TYPE];
+  Int              m_pcmBitDepths[MAX_NUM_CHANNEL_TYPE];
+  Bool             m_bPCMFilterDisableFlag;
+
+  UInt             m_uiBitsForPOC;
+  UInt             m_numLongTermRefPicSPS;
+  UInt             m_ltRefPicPocLsbSps[MAX_NUM_LONG_TERM_REF_PICS];
+  Bool             m_usedByCurrPicLtSPSFlag[MAX_NUM_LONG_TERM_REF_PICS];
+  // Max physical transform size
+  UInt             m_uiMaxTrSize;
+
+  Bool             m_bUseSAO;
+
+  Bool             m_bTemporalIdNestingFlag; // temporal_id_nesting_flag
+
+  Bool             m_scalingListEnabledFlag;
+  Bool             m_scalingListPresentFlag;
+  TComScalingList  m_scalingList;
+  UInt             m_uiMaxDecPicBuffering[MAX_TLAYER];
+  UInt             m_uiMaxLatencyIncrease[MAX_TLAYER];  // Really max latency increase plus 1 (value 0 expresses no limit)
+
+  Bool             m_useStrongIntraSmoothing;
+
+  Bool             m_vuiParametersPresentFlag;
+  TComVUI          m_vuiParameters;
+
+  TComSPSRExt      m_spsRangeExtension;
+
+  static const Int m_winUnitX[NUM_CHROMA_FORMAT];
+  static const Int m_winUnitY[NUM_CHROMA_FORMAT];
+  TComPTL          m_pcPTL;
+
+#if O0043_BEST_EFFORT_DECODING
+  UInt             m_forceDecodeBitDepth; // 0 = do not force the decoder's bit depth, other = force the decoder's bit depth to this value (best effort decoding)
+#endif
+#if NH_MV
+  TComVPS*         m_pcVPS; 
+  // SPS           
+  Int              m_spsMaxSubLayersMinus1;
+  Int              m_spsExtOrMaxSubLayersMinus1;
+  Bool             m_spsExtensionPresentFlag; 
+                   
+  Bool             m_spsRangeExtensionsFlag;
+  Bool             m_spsMultilayerExtensionFlag;
+
+  Bool             m_sps3dExtensionFlag;
+  Int              m_spsExtension5bits;
+
+  Bool             m_spsInferScalingListFlag;
+  Int              m_spsScalingListRefLayerId;
+  Bool             m_updateRepFormatFlag;
+  Int              m_spsRepFormatIdx;
+  // SPS Extension 
+  Bool             m_interViewMvVertConstraintFlag;
+#endif
+#if NH_3D
+  TComSps3dExtension m_sps3dExtension; 
+  Int              m_aaiCodedScale [2][MAX_NUM_LAYERS];
+  Int              m_aaiCodedOffset[2][MAX_NUM_LAYERS];
+#endif             
+#if NH_MV           
+  Int              m_layerId; 
+#endif
+
+public:
+                         TComSPS();
+  virtual                ~TComSPS();
+#if O0043_BEST_EFFORT_DECODING
+  Void                   setForceDecodeBitDepth(UInt bitDepth)                                           { m_forceDecodeBitDepth = bitDepth;                                    }
+  UInt                   getForceDecodeBitDepth()        const                                           { return m_forceDecodeBitDepth;                                        }
+#endif
+
+  Int                    getVPSId() const                                                                { return m_VPSId;                                                      }
+  Void                   setVPSId(Int i)                                                                 { m_VPSId = i;                                                         }
+  Int                    getSPSId() const                                                                { return m_SPSId;                                                      }
+  Void                   setSPSId(Int i)                                                                 { m_SPSId = i;                                                         }
+  ChromaFormat           getChromaFormatIdc () const                                                     { return m_chromaFormatIdc;                                            }
+  Void                   setChromaFormatIdc (ChromaFormat i)                                             { m_chromaFormatIdc = i;                                               }
+
+  static Int             getWinUnitX (Int chromaFormatIdc)                                               { assert (chromaFormatIdc >= 0 && chromaFormatIdc < NUM_CHROMA_FORMAT); return m_winUnitX[chromaFormatIdc]; }
+  static Int             getWinUnitY (Int chromaFormatIdc)                                               { assert (chromaFormatIdc >= 0 && chromaFormatIdc < NUM_CHROMA_FORMAT); return m_winUnitY[chromaFormatIdc]; }
+
+  // structure
+  Void                   setPicWidthInLumaSamples( UInt u )                                              { m_picWidthInLumaSamples = u;                                         }
+  UInt                   getPicWidthInLumaSamples() const                                                { return  m_picWidthInLumaSamples;                                     }
+  Void                   setPicHeightInLumaSamples( UInt u )                                             { m_picHeightInLumaSamples = u;                                        }
+  UInt                   getPicHeightInLumaSamples() const                                               { return  m_picHeightInLumaSamples;                                    }
+
+  Window&                getConformanceWindow()                                                          { return  m_conformanceWindow;                                         }
+  const Window&          getConformanceWindow() const                                                    { return  m_conformanceWindow;                                         }
+  Void                   setConformanceWindow(Window& conformanceWindow )                                { m_conformanceWindow = conformanceWindow;                             }
+
+  UInt                   getNumLongTermRefPicSPS() const                                                 { return m_numLongTermRefPicSPS;                                       }
+  Void                   setNumLongTermRefPicSPS(UInt val)                                               { m_numLongTermRefPicSPS = val;                                        }
+
+  UInt                   getLtRefPicPocLsbSps(UInt index) const                                          { assert( index < MAX_NUM_LONG_TERM_REF_PICS ); return m_ltRefPicPocLsbSps[index]; }
+  Void                   setLtRefPicPocLsbSps(UInt index, UInt val)                                      { assert( index < MAX_NUM_LONG_TERM_REF_PICS ); m_ltRefPicPocLsbSps[index] = val;  }
+
+  Bool                   getUsedByCurrPicLtSPSFlag(Int i) const                                          { assert( i < MAX_NUM_LONG_TERM_REF_PICS ); return m_usedByCurrPicLtSPSFlag[i];    }
+  Void                   setUsedByCurrPicLtSPSFlag(Int i, Bool x)                                        { assert( i < MAX_NUM_LONG_TERM_REF_PICS ); m_usedByCurrPicLtSPSFlag[i] = x;       }
+
+  Int                    getLog2MinCodingBlockSize() const                                               { return m_log2MinCodingBlockSize;                                     }
+  Void                   setLog2MinCodingBlockSize(Int val)                                              { m_log2MinCodingBlockSize = val;                                      }
+  Int                    getLog2DiffMaxMinCodingBlockSize() const                                        { return m_log2DiffMaxMinCodingBlockSize;                              }
+  Void                   setLog2DiffMaxMinCodingBlockSize(Int val)                                       { m_log2DiffMaxMinCodingBlockSize = val;                               }
+
+  Void                   setMaxCUWidth( UInt u )                                                         { m_uiMaxCUWidth = u;                                                  }
+  UInt                   getMaxCUWidth() const                                                           { return  m_uiMaxCUWidth;                                              }
+  Void                   setMaxCUHeight( UInt u )                                                        { m_uiMaxCUHeight = u;                                                 }
+  UInt                   getMaxCUHeight() const                                                          { return  m_uiMaxCUHeight;                                             }
+  Void                   setMaxTotalCUDepth( UInt u )                                                    { m_uiMaxTotalCUDepth = u;                                             }
+  UInt                   getMaxTotalCUDepth() const                                                      { return  m_uiMaxTotalCUDepth;                                         }
+  Void                   setUsePCM( Bool b )                                                             { m_usePCM = b;                                                        }
+  Bool                   getUsePCM() const                                                               { return m_usePCM;                                                     }
+  Void                   setPCMLog2MaxSize( UInt u )                                                     { m_pcmLog2MaxSize = u;                                                }
+  UInt                   getPCMLog2MaxSize() const                                                       { return  m_pcmLog2MaxSize;                                            }
+  Void                   setPCMLog2MinSize( UInt u )                                                     { m_uiPCMLog2MinSize = u;                                              }
+  UInt                   getPCMLog2MinSize() const                                                       { return  m_uiPCMLog2MinSize;                                          }
+  Void                   setBitsForPOC( UInt u )                                                         { m_uiBitsForPOC = u;                                                  }
+  UInt                   getBitsForPOC() const                                                           { return m_uiBitsForPOC;                                               }
+  Bool                   getUseAMP() const                                                               { return m_useAMP;                                                     }
+  Void                   setUseAMP( Bool b )                                                             { m_useAMP = b;                                                        }
+  Void                   setQuadtreeTULog2MaxSize( UInt u )                                              { m_uiQuadtreeTULog2MaxSize = u;                                       }
+  UInt                   getQuadtreeTULog2MaxSize() const                                                { return m_uiQuadtreeTULog2MaxSize;                                    }
+  Void                   setQuadtreeTULog2MinSize( UInt u )                                              { m_uiQuadtreeTULog2MinSize = u;                                       }
+  UInt                   getQuadtreeTULog2MinSize() const                                                { return m_uiQuadtreeTULog2MinSize;                                    }
+  Void                   setQuadtreeTUMaxDepthInter( UInt u )                                            { m_uiQuadtreeTUMaxDepthInter = u;                                     }
+  Void                   setQuadtreeTUMaxDepthIntra( UInt u )                                            { m_uiQuadtreeTUMaxDepthIntra = u;                                     }
+  UInt                   getQuadtreeTUMaxDepthInter() const                                              { return m_uiQuadtreeTUMaxDepthInter;                                  }
+  UInt                   getQuadtreeTUMaxDepthIntra() const                                              { return m_uiQuadtreeTUMaxDepthIntra;                                  }
+  Void                   setNumReorderPics(Int i, UInt tlayer)                                           { m_numReorderPics[tlayer] = i;                                        }
+  Int                    getNumReorderPics(UInt tlayer) const                                            { return m_numReorderPics[tlayer];                                     }
+  Void                   createRPSList( Int numRPS );
+  const TComRPSList*     getRPSList() const                                                              { return &m_RPSList;                                                   }
+  TComRPSList*           getRPSList()                                                                    { return &m_RPSList;                                                   }
+  Bool                   getLongTermRefsPresent() const                                                  { return m_bLongTermRefsPresent;                                       }
+  Void                   setLongTermRefsPresent(Bool b)                                                  { m_bLongTermRefsPresent=b;                                            }
+  Bool                   getTMVPFlagsPresent() const                                                     { return m_TMVPFlagsPresent;                                           }
+  Void                   setTMVPFlagsPresent(Bool b)                                                     { m_TMVPFlagsPresent=b;                                                }
+  // physical transform
+  Void                   setMaxTrSize( UInt u )                                                          { m_uiMaxTrSize = u;                                                   }
+  UInt                   getMaxTrSize() const                                                            { return  m_uiMaxTrSize;                                               }
+
+  // Bit-depth
+  Int                    getBitDepth(ChannelType type) const                                             { return m_bitDepths.recon[type];                                      }
+  Void                   setBitDepth(ChannelType type, Int u )                                           { m_bitDepths.recon[type] = u;                                         }
+#if O0043_BEST_EFFORT_DECODING
+  Int                    getStreamBitDepth(ChannelType type) const                                       { return m_bitDepths.stream[type];                                     }
+  Void                   setStreamBitDepth(ChannelType type, Int u )                                     { m_bitDepths.stream[type] = u;                                        }
+#endif
+  const BitDepths&       getBitDepths() const                                                            { return m_bitDepths;                                                  }
+  Int                    getMaxLog2TrDynamicRange(ChannelType channelType) const                         { return getSpsRangeExtension().getExtendedPrecisionProcessingFlag() ? std::max<Int>(15, Int(m_bitDepths.recon[channelType] + 6)) : 15; }
+
+  Int                    getDifferentialLumaChromaBitDepth() const                                       { return Int(m_bitDepths.recon[CHANNEL_TYPE_LUMA]) - Int(m_bitDepths.recon[CHANNEL_TYPE_CHROMA]); }
+  Int                    getQpBDOffset(ChannelType type) const                                           { return m_qpBDOffset[type];                                           }
+  Void                   setQpBDOffset(ChannelType type, Int i)                                          { m_qpBDOffset[type] = i;                                              }
+
+  Void                   setUseSAO(Bool bVal)                                                            { m_bUseSAO = bVal;                                                    }
+  Bool                   getUseSAO() const                                                               { return m_bUseSAO;                                                    }
+
+  UInt                   getMaxTLayers() const                                                           { return m_uiMaxTLayers; }
+  Void                   setMaxTLayers( UInt uiMaxTLayers )                                              { assert( uiMaxTLayers <= MAX_TLAYER ); m_uiMaxTLayers = uiMaxTLayers; }
+
+  Bool                   getTemporalIdNestingFlag() const                                                { return m_bTemporalIdNestingFlag;                                     }
+  Void                   setTemporalIdNestingFlag( Bool bValue )                                         { m_bTemporalIdNestingFlag = bValue;                                   }
+  UInt                   getPCMBitDepth(ChannelType type) const                                          { return m_pcmBitDepths[type];                                         }
+  Void                   setPCMBitDepth(ChannelType type, UInt u)                                        { m_pcmBitDepths[type] = u;                                            }
+  Void                   setPCMFilterDisableFlag( Bool bValue )                                          { m_bPCMFilterDisableFlag = bValue;                                    }
+  Bool                   getPCMFilterDisableFlag() const                                                 { return m_bPCMFilterDisableFlag;                                      }
+
+  Bool                   getScalingListFlag() const                                                      { return m_scalingListEnabledFlag;                                     }
+  Void                   setScalingListFlag( Bool b )                                                    { m_scalingListEnabledFlag  = b;                                       }
+  Bool                   getScalingListPresentFlag() const                                               { return m_scalingListPresentFlag;                                     }
+  Void                   setScalingListPresentFlag( Bool b )                                             { m_scalingListPresentFlag  = b;                                       }
+  Void                   setScalingList( TComScalingList *scalingList);
+  TComScalingList&       getScalingList()                                                                { return m_scalingList;                                                }
+  const TComScalingList& getScalingList() const                                                          { return m_scalingList;                                                }
+  UInt                   getMaxDecPicBuffering(UInt tlayer) const                                        { return m_uiMaxDecPicBuffering[tlayer];                               }
+  Void                   setMaxDecPicBuffering( UInt ui, UInt tlayer )                                   { assert(tlayer < MAX_TLAYER); m_uiMaxDecPicBuffering[tlayer] = ui;    }
+  UInt                   getMaxLatencyIncrease(UInt tlayer) const                                        { return m_uiMaxLatencyIncrease[tlayer];                               }
+  Void                   setMaxLatencyIncrease( UInt ui , UInt tlayer)                                   { m_uiMaxLatencyIncrease[tlayer] = ui;                                 }
+
+  Void                   setUseStrongIntraSmoothing(Bool bVal)                                           { m_useStrongIntraSmoothing = bVal;                                    }
+  Bool                   getUseStrongIntraSmoothing() const                                              { return m_useStrongIntraSmoothing;                                    }
+
+  Bool                   getVuiParametersPresentFlag() const                                             { return m_vuiParametersPresentFlag;                                   }
+  Void                   setVuiParametersPresentFlag(Bool b)                                             { m_vuiParametersPresentFlag = b;                                      }
+  TComVUI*               getVuiParameters()                                                              { return &m_vuiParameters;                                             }
+  const TComVUI*         getVuiParameters() const                                                        { return &m_vuiParameters;                                             }
+  const TComPTL*         getPTL() const                                                                  { return &m_pcPTL;                                                     }
+  TComPTL*               getPTL()                                                                        { return &m_pcPTL;                                                     }
+
+  const TComSPSRExt&     getSpsRangeExtension() const                                                    { return m_spsRangeExtension;                                          }
+  TComSPSRExt&           getSpsRangeExtension()                                                          { return m_spsRangeExtension;                                          }
+
+  // Sequence parameter set range extension syntax
+  // WAS: getUseResidualRotation and setUseResidualRotation
+  // Now getSpsRangeExtension().getTransformSkipRotationEnabledFlag and getSpsRangeExtension().setTransformSkipRotationEnabledFlag
+
+  // WAS: getUseSingleSignificanceMapContext and setUseSingleSignificanceMapContext
+  // Now: getSpsRangeExtension().getTransformSkipContextEnabledFlag and getSpsRangeExtension().setTransformSkipContextEnabledFlag
+
+  // WAS: getUseResidualDPCM and setUseResidualDPCM
+  // Now: getSpsRangeExtension().getRdpcmEnabledFlag and getSpsRangeExtension().setRdpcmEnabledFlag and
+
+  // WAS: getUseExtendedPrecision and setUseExtendedPrecision
+  // Now: getSpsRangeExtension().getExtendedPrecisionProcessingFlag and getSpsRangeExtension().setExtendedPrecisionProcessingFlag
+
+  // WAS: getDisableIntraReferenceSmoothing and setDisableIntraReferenceSmoothing
+  // Now: getSpsRangeExtension().getIntraSmoothingDisabledFlag and getSpsRangeExtension().setIntraSmoothingDisabledFlag
+
+  // WAS: getUseHighPrecisionPredictionWeighting and setUseHighPrecisionPredictionWeighting
+  // Now: getSpsRangeExtension().getHighPrecisionOffsetsEnabledFlag and getSpsRangeExtension().setHighPrecisionOffsetsEnabledFlag
+
+  // WAS: getUseGolombRiceParameterAdaptation and setUseGolombRiceParameterAdaptation
+  // Now: getSpsRangeExtension().getPersistentRiceAdaptationEnabledFlag and getSpsRangeExtension().setPersistentRiceAdaptationEnabledFlag
+
+  // WAS: getAlignCABACBeforeBypass and setAlignCABACBeforeBypass
+  // Now: getSpsRangeExtension().getCabacBypassAlignmentEnabledFlag and getSpsRangeExtension().setCabacBypassAlignmentEnabledFlag
+
+
+#if NH_MV
+
+  UInt                   getSpsMaxSubLayersMinus1() const                                                { return ( m_uiMaxTLayers - 1);                                        }
+  Void                   setSpsMaxSubLayersMinus1( UInt val )                                            { setMaxTLayers( val + 1 );                                            }
+
+  Void                   setSpsExtOrMaxSubLayersMinus1( Int  val )                                       { m_spsExtOrMaxSubLayersMinus1 = val;                                  }
+  Int                    getSpsExtOrMaxSubLayersMinus1(  )         const                                 { return m_spsExtOrMaxSubLayersMinus1;                                 }
+  Void                   inferSpsMaxSubLayersMinus1( Bool atPsActivation, TComVPS* vps  );                                                                                      
+                                                                                                                                                                                
+  Bool                   getMultiLayerExtSpsFlag()            const { return ( getLayerId() != 0  &&  getSpsExtOrMaxSubLayersMinus1() == 7 );                                   }
+  Void                   inferSpsMaxDecPicBufferingMinus1( TComVPS* vps, Int targetOptLayerSetIdx, Int currLayerId, Bool encoder );                                             
+                                                                                                                                                                                
+  Void                   setSpsExtensionPresentFlag( Bool flag )                                         { m_spsExtensionPresentFlag = flag;                                    }
+  Bool                   getSpsExtensionPresentFlag( )           const                                   { return m_spsExtensionPresentFlag;                                    }
+                                                                                                                                                                                
+  Void                   setSpsRangeExtensionsFlag( Bool flag )                                          { m_spsRangeExtensionsFlag = flag;                                     }
+  Bool                   getSpsRangeExtensionsFlag(  )                     const                         { return m_spsRangeExtensionsFlag;                                     }
+                                                                                                                                                                                
+  Void                   setSpsMultilayerExtensionFlag( Bool flag )                                      { m_spsMultilayerExtensionFlag = flag;                                 }
+  Bool                   getSpsMultilayerExtensionFlag( )                  const                         { return m_spsMultilayerExtensionFlag;                                 }
+
+  Void                   setSps3dExtensionFlag( Bool flag )                                              { m_sps3dExtensionFlag = flag;                                         }
+  Bool                   getSps3dExtensionFlag(  )                         const                         { return m_sps3dExtensionFlag;                                         }
+                                                                                                                                                                                
+  Void                   setSpsExtension5bits( Int  val )                                                { m_spsExtension5bits = val;                                           }
+  Int                    getSpsExtension5bits(  )                          const                         { return m_spsExtension5bits;                                          }
+                                                                                                                                                                                
+  Void                   setVPS          ( TComVPS* pcVPS )                                              { m_pcVPS = pcVPS;                                                     }
+  TComVPS*               getVPS          ()                 const                                        { return m_pcVPS;                                                      }
+                                                                                                                                                                                
+  Void                   setSpsInferScalingListFlag( Bool flag )                                         { m_spsInferScalingListFlag = flag;                                    }
+  Bool                   getSpsInferScalingListFlag(  )          const                                   { return m_spsInferScalingListFlag;                                    }
+                                                                                                                                                                                
+  Void                   setSpsScalingListRefLayerId( Int  val )                                         { m_spsScalingListRefLayerId = val;                                    }
+  Int                    getSpsScalingListRefLayerId(  )         const                                   { return m_spsScalingListRefLayerId;                                   }
+                                                                                                                                                                                
+  Void                   setUpdateRepFormatFlag( Bool flag )                                             { m_updateRepFormatFlag = flag;                                        }
+  Bool                   getUpdateRepFormatFlag(  )              const                                   { return m_updateRepFormatFlag;                                        }
   
-  Int         m_log2MinCodingBlockSize;
-  Int         m_log2DiffMaxMinCodingBlockSize;
-  UInt        m_uiMaxCUWidth;
-  UInt        m_uiMaxCUHeight;
-  UInt        m_uiMaxCUDepth;
-
-  Window      m_conformanceWindow;
-
-  TComRPSList m_RPSList;
-  Bool        m_bLongTermRefsPresent;
-  Bool        m_TMVPFlagsPresent;
-  Int         m_numReorderPics[MAX_TLAYER];
-  
-  // Tool list
-  UInt        m_uiQuadtreeTULog2MaxSize;
-  UInt        m_uiQuadtreeTULog2MinSize;
-  UInt        m_uiQuadtreeTUMaxDepthInter;
-  UInt        m_uiQuadtreeTUMaxDepthIntra;
-  Bool        m_usePCM;
-  UInt        m_pcmLog2MaxSize;
-  UInt        m_uiPCMLog2MinSize;
-  Bool        m_useAMP;
-
-  // Parameter
-  Int         m_bitDepthY;
-  Int         m_bitDepthC;
-  Int         m_qpBDOffsetY;
-  Int         m_qpBDOffsetC;
-
-  UInt        m_uiPCMBitDepthLuma;
-  UInt        m_uiPCMBitDepthChroma;
-  Bool        m_bPCMFilterDisableFlag;
-
-  UInt        m_uiBitsForPOC;
-
-  UInt        m_numLongTermRefPicSPS;
-  UInt        m_ltRefPicPocLsbSps[33];
-  Bool        m_usedByCurrPicLtSPSFlag[33];
-  // Max physical transform size
-  UInt        m_uiMaxTrSize;
-  
-  Int m_iAMPAcc[MAX_CU_DEPTH];
-  Bool        m_bUseSAO; 
-
-  Bool        m_bTemporalIdNestingFlag; // temporal_id_nesting_flag
-
-  Bool        m_scalingListEnabledFlag;
-  Bool        m_scalingListPresentFlag;
-  TComScalingList*     m_scalingList;   //!< ScalingList class pointer
-  UInt        m_uiMaxDecPicBuffering[MAX_TLAYER]; 
-  UInt        m_uiMaxLatencyIncrease[MAX_TLAYER];  // Really max latency increase plus 1 (value 0 expresses no limit)
-
-  Bool        m_useDF;
-  Bool        m_useStrongIntraSmoothing;
-
-  Bool        m_vuiParametersPresentFlag;
-  TComVUI     m_vuiParameters;
-
-  static const Int   m_winUnitX[MAX_CHROMA_FORMAT_IDC+1];
-  static const Int   m_winUnitY[MAX_CHROMA_FORMAT_IDC+1];
-  TComPTL     m_pcPTL;
-#if H_MV
-  TComVPS*    m_pcVPS; 
-  // SPS 
-  Int         m_spsMaxSubLayersMinus1;
-  Int         m_spsExtOrMaxSubLayersMinus1;
-  Bool        m_spsExtensionPresentFlag; 
-
-  Bool        m_spsRangeExtensionsFlag;
-  Bool        m_spsMultilayerExtensionFlag;
-#if H_3D
-  Bool        m_sps3dExtensionFlag;
-  Int         m_spsExtension5bits;
-#else
-  Int         m_spsExtension6bits;
-#endif
-
-  Bool        m_spsInferScalingListFlag;
-  Int         m_spsScalingListRefLayerId;
-  Bool        m_updateRepFormatFlag;
-  Int         m_spsRepFormatIdx;
-  // SPS Extension 
-  Bool        m_interViewMvVertConstraintFlag;
-#endif
-#if H_3D
-  TComSps3dExtension m_sps3dExtension; 
-  Int         m_aaiCodedScale [2][MAX_NUM_LAYERS];
-  Int         m_aaiCodedOffset[2][MAX_NUM_LAYERS];
-#endif
-#if H_MV
-  Int         m_layerId; 
-#endif
-public:
-  TComSPS();
-  virtual ~TComSPS();
-
-  Int  getVPSId       ()         { return m_VPSId;          }
-  Void setVPSId       (Int i)    { m_VPSId = i;             }
-  Int  getSPSId       ()         { return m_SPSId;          }
-  Void setSPSId       (Int i)    { m_SPSId = i;             }
-  Int  getChromaFormatIdc ()         { return m_chromaFormatIdc;       }
-  Void setChromaFormatIdc (Int i)    { m_chromaFormatIdc = i;          }
-
-#if H_3D_DISABLE_CHROMA
-  static Int getWinUnitX (Int chromaFormatIdc) { assert (chromaFormatIdc >= 0 && chromaFormatIdc <= MAX_CHROMA_FORMAT_IDC); return m_winUnitX[chromaFormatIdc];      }
-  static Int getWinUnitY (Int chromaFormatIdc) { assert (chromaFormatIdc >= 0 && chromaFormatIdc <= MAX_CHROMA_FORMAT_IDC); return m_winUnitY[chromaFormatIdc];      }
-#else
-  static Int getWinUnitX (Int chromaFormatIdc) { assert (chromaFormatIdc > 0 && chromaFormatIdc <= MAX_CHROMA_FORMAT_IDC); return m_winUnitX[chromaFormatIdc];      }
-  static Int getWinUnitY (Int chromaFormatIdc) { assert (chromaFormatIdc > 0 && chromaFormatIdc <= MAX_CHROMA_FORMAT_IDC); return m_winUnitY[chromaFormatIdc];      }
-#endif
-  
-  // structure
-  Void setPicWidthInLumaSamples       ( UInt u ) { m_picWidthInLumaSamples = u;        }
-  UInt getPicWidthInLumaSamples       ()         { return  m_picWidthInLumaSamples;    }
-  Void setPicHeightInLumaSamples      ( UInt u ) { m_picHeightInLumaSamples = u;       }
-  UInt getPicHeightInLumaSamples      ()         { return  m_picHeightInLumaSamples;   }
-
-  Window& getConformanceWindow()                           { return  m_conformanceWindow;             }
-  Void    setConformanceWindow(Window& conformanceWindow ) { m_conformanceWindow = conformanceWindow; }
-
-  UInt  getNumLongTermRefPicSPS()             { return m_numLongTermRefPicSPS; }
-  Void  setNumLongTermRefPicSPS(UInt val)     { m_numLongTermRefPicSPS = val; }
-
-  UInt  getLtRefPicPocLsbSps(UInt index)             { return m_ltRefPicPocLsbSps[index]; }
-  Void  setLtRefPicPocLsbSps(UInt index, UInt val)     { m_ltRefPicPocLsbSps[index] = val; }
-
-  Bool getUsedByCurrPicLtSPSFlag(Int i)        {return m_usedByCurrPicLtSPSFlag[i];}
-  Void setUsedByCurrPicLtSPSFlag(Int i, Bool x)      { m_usedByCurrPicLtSPSFlag[i] = x;}
-
-  Int  getLog2MinCodingBlockSize() const           { return m_log2MinCodingBlockSize; }
-  Void setLog2MinCodingBlockSize(Int val)          { m_log2MinCodingBlockSize = val; }
-  Int  getLog2DiffMaxMinCodingBlockSize() const    { return m_log2DiffMaxMinCodingBlockSize; }
-  Void setLog2DiffMaxMinCodingBlockSize(Int val)   { m_log2DiffMaxMinCodingBlockSize = val; }
-
-  Void setMaxCUWidth  ( UInt u ) { m_uiMaxCUWidth = u;      }
-  UInt getMaxCUWidth  ()         { return  m_uiMaxCUWidth;  }
-  Void setMaxCUHeight ( UInt u ) { m_uiMaxCUHeight = u;     }
-  UInt getMaxCUHeight ()         { return  m_uiMaxCUHeight; }
-  Void setMaxCUDepth  ( UInt u ) { m_uiMaxCUDepth = u;      }
-  UInt getMaxCUDepth  ()         { return  m_uiMaxCUDepth;  }
-  Void setUsePCM      ( Bool b ) { m_usePCM = b;           }
-  Bool getUsePCM      ()         { return m_usePCM;        }
-  Void setPCMLog2MaxSize  ( UInt u ) { m_pcmLog2MaxSize = u;      }
-  UInt getPCMLog2MaxSize  ()         { return  m_pcmLog2MaxSize;  }
-  Void setPCMLog2MinSize  ( UInt u ) { m_uiPCMLog2MinSize = u;      }
-  UInt getPCMLog2MinSize  ()         { return  m_uiPCMLog2MinSize;  }
-  Void setBitsForPOC  ( UInt u ) { m_uiBitsForPOC = u;      }
-  UInt getBitsForPOC  ()         { return m_uiBitsForPOC;   }
-  Bool getUseAMP() { return m_useAMP; }
-  Void setUseAMP( Bool b ) { m_useAMP = b; }
-  Void setQuadtreeTULog2MaxSize( UInt u ) { m_uiQuadtreeTULog2MaxSize = u;    }
-  UInt getQuadtreeTULog2MaxSize()         { return m_uiQuadtreeTULog2MaxSize; }
-  Void setQuadtreeTULog2MinSize( UInt u ) { m_uiQuadtreeTULog2MinSize = u;    }
-  UInt getQuadtreeTULog2MinSize()         { return m_uiQuadtreeTULog2MinSize; }
-  Void setQuadtreeTUMaxDepthInter( UInt u ) { m_uiQuadtreeTUMaxDepthInter = u;    }
-  Void setQuadtreeTUMaxDepthIntra( UInt u ) { m_uiQuadtreeTUMaxDepthIntra = u;    }
-  UInt getQuadtreeTUMaxDepthInter()         { return m_uiQuadtreeTUMaxDepthInter; }
-  UInt getQuadtreeTUMaxDepthIntra()         { return m_uiQuadtreeTUMaxDepthIntra; }
-  Void setNumReorderPics(Int i, UInt tlayer)              { m_numReorderPics[tlayer] = i;    }
-  Int  getNumReorderPics(UInt tlayer)                     { return m_numReorderPics[tlayer]; }
-  Void         createRPSList( Int numRPS );
-  TComRPSList* getRPSList()                      { return &m_RPSList;          }
-  Bool      getLongTermRefsPresent()         { return m_bLongTermRefsPresent; }
-  Void      setLongTermRefsPresent(Bool b)   { m_bLongTermRefsPresent=b;      }
-  Bool      getTMVPFlagsPresent()         { return m_TMVPFlagsPresent; }
-  Void      setTMVPFlagsPresent(Bool b)   { m_TMVPFlagsPresent=b;      }  
-  // physical transform
-  Void setMaxTrSize   ( UInt u ) { m_uiMaxTrSize = u;       }
-  UInt getMaxTrSize   ()         { return  m_uiMaxTrSize;   }
-  
-  // AMP accuracy
-  Int       getAMPAcc   ( UInt uiDepth ) { return m_iAMPAcc[uiDepth]; }
-  Void      setAMPAcc   ( UInt uiDepth, Int iAccu ) { assert( uiDepth < g_uiMaxCUDepth);  m_iAMPAcc[uiDepth] = iAccu; }
-
-  // Bit-depth
-  Int      getBitDepthY() { return m_bitDepthY; }
-  Void     setBitDepthY(Int u) { m_bitDepthY = u; }
-  Int      getBitDepthC() { return m_bitDepthC; }
-  Void     setBitDepthC(Int u) { m_bitDepthC = u; }
-  Int       getQpBDOffsetY  ()             { return m_qpBDOffsetY;   }
-  Void      setQpBDOffsetY  ( Int value  ) { m_qpBDOffsetY = value;  }
-  Int       getQpBDOffsetC  ()             { return m_qpBDOffsetC;   }
-  Void      setQpBDOffsetC  ( Int value  ) { m_qpBDOffsetC = value;  }
-  Void setUseSAO                  (Bool bVal)  {m_bUseSAO = bVal;}
-  Bool getUseSAO                  ()           {return m_bUseSAO;}
-
-  UInt      getMaxTLayers()                           { return m_uiMaxTLayers; }
-  Void      setMaxTLayers( UInt uiMaxTLayers )        { assert( uiMaxTLayers <= MAX_TLAYER ); m_uiMaxTLayers = uiMaxTLayers; }
-#if H_MV
-  UInt      getSpsMaxSubLayersMinus1()                { return ( m_uiMaxTLayers - 1); }
-  Void      setSpsMaxSubLayersMinus1( UInt val )       { setMaxTLayers( val + 1 ); }
-#endif
-
-  Bool      getTemporalIdNestingFlag()                { return m_bTemporalIdNestingFlag; }
-  Void      setTemporalIdNestingFlag( Bool bValue )   { m_bTemporalIdNestingFlag = bValue; }
-  UInt      getPCMBitDepthLuma     ()         { return m_uiPCMBitDepthLuma;     }
-  Void      setPCMBitDepthLuma     ( UInt u ) { m_uiPCMBitDepthLuma = u;        }
-  UInt      getPCMBitDepthChroma   ()         { return m_uiPCMBitDepthChroma;   }
-  Void      setPCMBitDepthChroma   ( UInt u ) { m_uiPCMBitDepthChroma = u;      }
-  Void      setPCMFilterDisableFlag     ( Bool   bValue  )    { m_bPCMFilterDisableFlag = bValue; }
-  Bool      getPCMFilterDisableFlag     ()                    { return m_bPCMFilterDisableFlag;   } 
-
-  Bool getScalingListFlag       ()         { return m_scalingListEnabledFlag;     }
-  Void setScalingListFlag       ( Bool b ) { m_scalingListEnabledFlag  = b;       }
-  Bool getScalingListPresentFlag()         { return m_scalingListPresentFlag;     }
-  Void setScalingListPresentFlag( Bool b ) { m_scalingListPresentFlag  = b;       }
-  Void setScalingList      ( TComScalingList *scalingList);
-  TComScalingList* getScalingList ()       { return m_scalingList; }               //!< get ScalingList class pointer in SPS
-  UInt getMaxDecPicBuffering  (UInt tlayer)            { return m_uiMaxDecPicBuffering[tlayer]; }
-  Void setMaxDecPicBuffering  ( UInt ui, UInt tlayer ) { assert(tlayer < MAX_TLAYER);  m_uiMaxDecPicBuffering[tlayer] = ui;   }
-  UInt getMaxLatencyIncrease  (UInt tlayer)            { return m_uiMaxLatencyIncrease[tlayer];   }
-  Void setMaxLatencyIncrease  ( UInt ui , UInt tlayer) { m_uiMaxLatencyIncrease[tlayer] = ui;      }
-
-  Void setUseStrongIntraSmoothing (Bool bVal)  {m_useStrongIntraSmoothing = bVal;}
-  Bool getUseStrongIntraSmoothing ()           {return m_useStrongIntraSmoothing;}
-
-  Bool getVuiParametersPresentFlag() { return m_vuiParametersPresentFlag; }
-  Void setVuiParametersPresentFlag(Bool b) { m_vuiParametersPresentFlag = b; }
-  TComVUI* getVuiParameters() { return &m_vuiParameters; }
-  Void setHrdParameters( UInt frameRate, UInt numDU, UInt bitRate, Bool randomAccess );
-
-  TComPTL* getPTL()     { return &m_pcPTL; }
-#if H_MV
-  Void setSpsExtOrMaxSubLayersMinus1( Int  val ) { m_spsExtOrMaxSubLayersMinus1 = val; } 
-  Int  getSpsExtOrMaxSubLayersMinus1(  ) { return m_spsExtOrMaxSubLayersMinus1; } 
-  Void inferSpsMaxSubLayersMinus1( Bool atPsActivation, TComVPS* vps  );
-
-  Bool getMultiLayerExtSpsFlag()            { return ( getLayerId() != 0  &&  getSpsExtOrMaxSubLayersMinus1() == 7 ); }
-  Void inferSpsMaxDecPicBufferingMinus1( TComVPS* vps, Int targetOptLayerSetIdx, Int currLayerId, Bool encoder );
-
-  Void setSpsExtensionPresentFlag( Bool flag ) { m_spsExtensionPresentFlag = flag; } 
-  Bool getSpsExtensionPresentFlag( )           { return m_spsExtensionPresentFlag; }
-
-  Void setSpsRangeExtensionsFlag( Bool flag )            { m_spsRangeExtensionsFlag = flag; } 
-  Bool getSpsRangeExtensionsFlag(  )                     { return m_spsRangeExtensionsFlag; } 
-
-  Void setSpsMultilayerExtensionFlag( Bool flag )        { m_spsMultilayerExtensionFlag = flag; } 
-  Bool getSpsMultilayerExtensionFlag( )                  { return m_spsMultilayerExtensionFlag; } 
-#if H_3D
-  Void setSps3dExtensionFlag( Bool flag )                { m_sps3dExtensionFlag = flag; } 
-  Bool getSps3dExtensionFlag(  )                        { return m_sps3dExtensionFlag; } 
-
-  Void setSpsExtension5bits( Int  val )                  { m_spsExtension5bits = val; } 
-  Int  getSpsExtension5bits(  )                          { return m_spsExtension5bits; } 
-#else
-  Void setSpsExtension6bits( Int  val )                  { m_spsExtension6bits = val; } 
-  Int  getSpsExtension6bits(  )                          { return m_spsExtension6bits; } 
-#endif
-  
-  Void      setVPS          ( TComVPS* pcVPS ) { m_pcVPS = pcVPS; }
-  TComVPS*  getVPS          () { return m_pcVPS; }
-
-  Void setSpsInferScalingListFlag( Bool flag ) { m_spsInferScalingListFlag = flag; } 
-  Bool getSpsInferScalingListFlag(  )          { return m_spsInferScalingListFlag; } 
-
-  Void setSpsScalingListRefLayerId( Int  val ) { m_spsScalingListRefLayerId = val; } 
-  Int  getSpsScalingListRefLayerId(  )         { return m_spsScalingListRefLayerId; } 
-
-  Void setUpdateRepFormatFlag( Bool flag )     { m_updateRepFormatFlag = flag; } 
-  Bool getUpdateRepFormatFlag(  )              { return m_updateRepFormatFlag; } 
-  Void setSpsRepFormatIdx( Int  val )          { m_spsRepFormatIdx = val; } 
-  Int  getSpsRepFormatIdx(  )                  { return m_spsRepFormatIdx; } 
-  
-// SPS Extension 
-  Void setInterViewMvVertConstraintFlag(Bool val) { m_interViewMvVertConstraintFlag = val; }
-  Bool getInterViewMvVertConstraintFlag()         { return m_interViewMvVertConstraintFlag;}
-
-#if H_3D
-  Void setSps3dExtension ( TComSps3dExtension& sps3dExtension ) { m_sps3dExtension = sps3dExtension; }
-  TComSps3dExtension* getSps3dExtension ( )                     { return &m_sps3dExtension; }
-#endif
-
-  // Inference 
-
-  Void inferRepFormat( TComVPS* vps, Int layerIdCurr );
-  Void inferScalingList( TComSPS* spsSrc );
-
-  // others
-  Void checkRpsMaxNumPics( TComVPS* vps, Int currLayerId );
-
-#endif
-#if H_MV
-  Int  getLayerId            ()           { return m_layerId; }
-  Void setLayerId            ( Int val )  { m_layerId = val; }
+  Void                   setSpsRepFormatIdx( Int  val )                                                  { m_spsRepFormatIdx = val;                                             }
+  Int                    getSpsRepFormatIdx(  )                  const                                   { return m_spsRepFormatIdx;                                            }
+                                                                                                                                                                                
+// SPS Extension                                                                                                                                                                
+  Void                   setInterViewMvVertConstraintFlag(Bool val)                                      { m_interViewMvVertConstraintFlag = val;                               }
+  Bool                   getInterViewMvVertConstraintFlag()         const                                { return m_interViewMvVertConstraintFlag;                              }
+                                                                                                                                                                                
+#if NH_3D
+  Void                   setSps3dExtension ( TComSps3dExtension& sps3dExtension )                        { m_sps3dExtension = sps3dExtension;                                   }
+  const TComSps3dExtension* getSps3dExtension ( )  const                                                 { return &m_sps3dExtension;                                            } 
+#endif                  
+                        
+  // Inference          
+                        
+  Void                   inferRepFormat( TComVPS* vps, Int layerIdCurr, Bool encoder );
+  Void                   inferScalingList( const TComSPS* spsSrc );
+                        
+  // others             
+  Void                   checkRpsMaxNumPics( const TComVPS* vps, Int currLayerId ) const;
+                        
+  Int                    getLayerId            ()           const                                        { return m_layerId;                                                    }
+  Void                   setLayerId            ( Int val )                                               { m_layerId = val;                                                     }
+
 #endif
 
 };
 
+
 /// Reference Picture Lists class
+
 class TComRefPicListModification
 {
 private:
-  UInt      m_bRefPicListModificationFlagL0;  
-  UInt      m_bRefPicListModificationFlagL1;  
-  UInt      m_RefPicSetIdxL0[32];
-  UInt      m_RefPicSetIdxL1[32];
-    
+  Bool m_refPicListModificationFlagL0;
+  Bool m_refPicListModificationFlagL1;
+  UInt m_RefPicSetIdxL0[REF_PIC_LIST_NUM_IDX];
+  UInt m_RefPicSetIdxL1[REF_PIC_LIST_NUM_IDX];
+
 public:
-  TComRefPicListModification();
+          TComRefPicListModification();
   virtual ~TComRefPicListModification();
-  
-  Void  create                    ();
-  Void  destroy                   ();
-
-  Bool       getRefPicListModificationFlagL0() { return m_bRefPicListModificationFlagL0; }
-  Void       setRefPicListModificationFlagL0(Bool flag) { m_bRefPicListModificationFlagL0 = flag; }
-  Bool       getRefPicListModificationFlagL1() { return m_bRefPicListModificationFlagL1; }
-  Void       setRefPicListModificationFlagL1(Bool flag) { m_bRefPicListModificationFlagL1 = flag; }
-  Void       setRefPicSetIdxL0(UInt idx, UInt refPicSetIdx) { m_RefPicSetIdxL0[idx] = refPicSetIdx; }
-  UInt       getRefPicSetIdxL0(UInt idx) { return m_RefPicSetIdxL0[idx]; }
-  Void       setRefPicSetIdxL1(UInt idx, UInt refPicSetIdx) { m_RefPicSetIdxL1[idx] = refPicSetIdx; }
-  UInt       getRefPicSetIdxL1(UInt idx) { return m_RefPicSetIdxL1[idx]; }
-#if H_MV
-  // Why not an listIdx for all members, would avoid code duplication?? 
-  Void       setRefPicSetIdxL(UInt li, UInt idx, UInt refPicSetIdx) {( li==0 ? m_RefPicSetIdxL0[idx] : m_RefPicSetIdxL1[idx] ) = refPicSetIdx; }
-  UInt       getRefPicSetIdxL(UInt li, UInt idx ) { return ( li == 0 ) ? m_RefPicSetIdxL0[idx] : m_RefPicSetIdxL1[idx] ; }
-  Void       setRefPicListModificationFlagL(UInt li, Bool flag) { ( li==0  ? m_bRefPicListModificationFlagL0 : m_bRefPicListModificationFlagL1 ) = flag;  }
-  Bool       getRefPicListModificationFlagL(UInt li ) { return ( li== 0) ? m_bRefPicListModificationFlagL0 : m_bRefPicListModificationFlagL1; }
+
+  Void    create();
+  Void    destroy();
+
+  Bool    getRefPicListModificationFlagL0() const        { return m_refPicListModificationFlagL0;                                  }
+  Void    setRefPicListModificationFlagL0(Bool flag)     { m_refPicListModificationFlagL0 = flag;                                  }
+  Bool    getRefPicListModificationFlagL1() const        { return m_refPicListModificationFlagL1;                                  }
+  Void    setRefPicListModificationFlagL1(Bool flag)     { m_refPicListModificationFlagL1 = flag;                                  }
+  UInt    getRefPicSetIdxL0(UInt idx) const              { assert(idx<REF_PIC_LIST_NUM_IDX); return m_RefPicSetIdxL0[idx];         }
+  Void    setRefPicSetIdxL0(UInt idx, UInt refPicSetIdx) { assert(idx<REF_PIC_LIST_NUM_IDX); m_RefPicSetIdxL0[idx] = refPicSetIdx; }
+  UInt    getRefPicSetIdxL1(UInt idx) const              { assert(idx<REF_PIC_LIST_NUM_IDX); return m_RefPicSetIdxL1[idx];         }
+  Void    setRefPicSetIdxL1(UInt idx, UInt refPicSetIdx) { assert(idx<REF_PIC_LIST_NUM_IDX); m_RefPicSetIdxL1[idx] = refPicSetIdx; }
+#if NH_MV
+  // Why not a listIdx for all members, would avoid code duplication?? 
+  Void    setRefPicSetIdxL(UInt li, UInt idx, UInt refPicSetIdx) {( li==0 ? m_RefPicSetIdxL0[idx] : m_RefPicSetIdxL1[idx] ) = refPicSetIdx;              }
+  UInt    getRefPicSetIdxL(UInt li, UInt idx )                   { return ( li == 0 ) ? m_RefPicSetIdxL0[idx] : m_RefPicSetIdxL1[idx] ;                  }
+  Void    setRefPicListModificationFlagL(UInt li, Bool flag)     { ( li==0  ? m_refPicListModificationFlagL0 : m_refPicListModificationFlagL1 ) = flag;  }
+  Bool    getRefPicListModificationFlagL(UInt li )               { return ( li== 0) ? m_refPicListModificationFlagL0 : m_refPicListModificationFlagL1;   }
 #endif
 };
+
+/// PPS RExt class
+class TComPPSRExt // Names aligned to text specification
+{
+private:
+  Int              m_log2MaxTransformSkipBlockSize;
+  Bool             m_crossComponentPredictionEnabledFlag;
+
+  // Chroma QP Adjustments
+  Int              m_diffCuChromaQpOffsetDepth;
+  Int              m_chromaQpOffsetListLen; // size (excludes the null entry used in the following array).
+  ChromaQpAdj      m_ChromaQpAdjTableIncludingNullEntry[1+MAX_QP_OFFSET_LIST_SIZE]; //!< Array includes entry [0] for the null offset used when cu_chroma_qp_offset_flag=0, and entries [cu_chroma_qp_offset_idx+1...] otherwise
+
+  UInt             m_log2SaoOffsetScale[MAX_NUM_CHANNEL_TYPE];
+
+public:
+  TComPPSRExt();
+
+  Bool settingsDifferFromDefaults(const bool bTransformSkipEnabledFlag) const
+  {
+    return (bTransformSkipEnabledFlag && (getLog2MaxTransformSkipBlockSize() !=2))
+        || (getCrossComponentPredictionEnabledFlag() )
+        || (getChromaQpOffsetListEnabledFlag() )
+        || (getLog2SaoOffsetScale(CHANNEL_TYPE_LUMA) !=0 )
+        || (getLog2SaoOffsetScale(CHANNEL_TYPE_CHROMA) !=0 );
+  }
+
+  UInt                   getLog2MaxTransformSkipBlockSize() const                         { return m_log2MaxTransformSkipBlockSize;         }
+  Void                   setLog2MaxTransformSkipBlockSize( UInt u )                       { m_log2MaxTransformSkipBlockSize  = u;           }
+
+  Bool                   getCrossComponentPredictionEnabledFlag() const                   { return m_crossComponentPredictionEnabledFlag;   }
+  Void                   setCrossComponentPredictionEnabledFlag(Bool value)               { m_crossComponentPredictionEnabledFlag = value;  }
+
+  Void                   clearChromaQpOffsetList()                                        { m_chromaQpOffsetListLen = 0;                    }
+
+  UInt                   getDiffCuChromaQpOffsetDepth () const                            { return m_diffCuChromaQpOffsetDepth;             }
+  Void                   setDiffCuChromaQpOffsetDepth ( UInt u )                          { m_diffCuChromaQpOffsetDepth = u;                }
+
+  Bool                   getChromaQpOffsetListEnabledFlag() const                         { return getChromaQpOffsetListLen()>0;            }
+  Int                    getChromaQpOffsetListLen() const                                 { return m_chromaQpOffsetListLen;                 }
+
+  const ChromaQpAdj&     getChromaQpOffsetListEntry( Int cuChromaQpOffsetIdxPlus1 ) const
+  {
+    assert(cuChromaQpOffsetIdxPlus1 < m_chromaQpOffsetListLen+1);
+    return m_ChromaQpAdjTableIncludingNullEntry[cuChromaQpOffsetIdxPlus1]; // Array includes entry [0] for the null offset used when cu_chroma_qp_offset_flag=0, and entries [cu_chroma_qp_offset_idx+1...] otherwise
+  }
+
+  Void                   setChromaQpOffsetListEntry( Int cuChromaQpOffsetIdxPlus1, Int cbOffset, Int crOffset )
+  {
+    assert (cuChromaQpOffsetIdxPlus1 != 0 && cuChromaQpOffsetIdxPlus1 <= MAX_QP_OFFSET_LIST_SIZE);
+    m_ChromaQpAdjTableIncludingNullEntry[cuChromaQpOffsetIdxPlus1].u.comp.CbOffset = cbOffset; // Array includes entry [0] for the null offset used when cu_chroma_qp_offset_flag=0, and entries [cu_chroma_qp_offset_idx+1...] otherwise
+    m_ChromaQpAdjTableIncludingNullEntry[cuChromaQpOffsetIdxPlus1].u.comp.CrOffset = crOffset;
+    m_chromaQpOffsetListLen = max(m_chromaQpOffsetListLen, cuChromaQpOffsetIdxPlus1);
+  }
+
+  // Now: getPpsRangeExtension().getLog2SaoOffsetScale and getPpsRangeExtension().setLog2SaoOffsetScale
+  UInt                   getLog2SaoOffsetScale(ChannelType type) const                    { return m_log2SaoOffsetScale[type];             }
+  Void                   setLog2SaoOffsetScale(ChannelType type, UInt uiBitShift)         { m_log2SaoOffsetScale[type] = uiBitShift;       }
+
+};
+
 
 /// PPS class
